<'

----------------------------------------------------------------------------
struct sql_cover_s like user_cover_struct {
    db_init_mode : bool ; 
   !sql_cover_tc   : string;
   !sql_cover_user : string;

   scan_bucket() is also {
         --specman("config cover -show_sub_holes");
         var monitor_name : string;
         var event_name : string;
         var record : string;
         var fbn : string = "";
         for each in full_bucket_name {
            fbn = append(fbn, "_", it );
         };
         fbn = str_replace(fbn, "/^(_)/", ""); -- get rid of first _
         monitor_name = append(
                             struct_name, "_",
                             group_name, "_",
                             item_name 
                              );
         event_name   = append (
                             monitor_name,".",
                             fbn 
                                );
         if (not db_init_mode) and (count > 0) and (struct_name != "session"){
            record       = append (
                             sql_cover_tc,"\t",
                             event_name,"\t",
                             sql_cover_user,"\t",
                             count.to_string(),"\t",
                             "-1\t0.0"
                                );
            files.write(sys.sql_cover_db_file, record );
         }; -- if (not db_init_mode)
         if (db_init_mode) and (struct_name != "session"){
            record       = append (
                             event_name,"\t",
                             "1"
                                );
            files.write(sys.sql_cover_db_file, record );
         }; --if (db_init_mode)
       
   }; --scan_bucket() is also
}; --struct sql_cover_s

extend sys {
    !sql_cover_db_file      : file;
    !sql_cover_test_file    : file;
    !sql_cover : sql_cover_s;
    sql_cover_switch : enable_t;
       keep soft sql_cover_switch == DISABLED;
    sql_cover_db_init_mod : bool;
       keep soft sql_cover_db_init_mod == FALSE;
    
    sql_cover_db_file_name : string;
       keep soft sql_cover_db_file_name   == "specmandb.log";
    sql_cover_test_file_name : string;
       keep soft sql_cover_test_file_name == "specman_test.log";
    
    init() is also {
        sql_cover = new;
        sql_cover.db_init_mode = sql_cover_db_init_mod;
    };
};

extend global {
       
    finalize_test() is also {
        if (sys.sql_cover_switch == ENABLED ) {dump_mre_format()};
    };
    
    dump_mre_format() is {
        set_config(print, radix, dec);
        ----------- write test information 
        var blah : uint;
        var sql_cover_tc : string;
        var sql_cover_passed : string;
        sys.sql_cover_test_file = files.open(sys.sql_cover_test_file_name, "w", "Text file");
        var record : string;
        var cycles := sys.trace_logger.trace_clock_count.to_string();
        if (session.num_of_dut_errors > 0) or (session.num_of_dut_warnings > 0) {
          sql_cover_passed = "0";
        }
        else {
          sql_cover_passed = "1";
        };
        sql_cover_tc = get_symbol("TCE_TEST_NAME");
        if (get_symbol("TCE_TYPE") != "Asm") { 
           sql_cover_tc = appendf ("%s_0x%08x", sql_cover_tc, params.seed) ;                             
        };
        record  = append (
                           sql_cover_tc,"\t",
                           cycles,"\t",
                           sql_cover_passed,"\t",
                           "0.0\n"
                           );
        files.write(sys.sql_cover_test_file, record );
        files.close(sys.sql_cover_test_file);
        
        ----------- write coverage db information 
        sys.sql_cover_db_file = files.open(sys.sql_cover_db_file_name, "w", "Text file");
        sys.sql_cover.sql_cover_tc = sql_cover_tc;
        sys.sql_cover.sql_cover_user = get_symbol("USER");
        blah = sys.sql_cover.scan_cover("*.*.*");
        files.close(sys.sql_cover_db_file);
    };
};

 
'>
