//*******************************************************************************
//* File:        toolbox.e
//* By:          Jerel Canales (Texas Instruments)
//* Company:     Texas Instruments, Inc.
//* Purpose:     Library for essential DV structs
//*                
//* sys_logger.e   ->  provides methods for general sim logging
//* trace_logger.e ->  provides methods for detailed trace logging
//* watch.e        ->  provides methods for controlling when the sim is stopped. 
//*                    such as a report_done method for a normal stop mechanism
//*                    and a test watchdog method for emergency stopping.
//* switch.e       ->  switch struct defines chk, monitor & module
//*                    mechanism for enabling/disabling
//* clock.e        ->  defines clock's events
//*
//******************************************************************************/
<'
    
-- Common Structs --
import trace_logger.e;
import switch.e;
import clock.e;
import watch.e;
import sql_cover.e;

import reset_driver.e;

'>
    
