//********************************************************************************
//
//  Filename: cpubus_global.e
//
//  Description: global configurations
//
//  Major Revision Descriptions:
//  oishi          09/08/02         copied from UMA1.0 branch
//
//*********************************************************************************

--------------------------
-- global configuration --
--------------------------
<'
extend global {

    setup_test() is also {
        -- the following commands will configure the built-in error handling
        -- to perform the following functionality:
        -- dut_error("FATAL:   blah,blah,blah") will stop the sim before next clock
        -- dut_error("ERROR:   blah,blah,blah") will count an error and continue to run
        -- dut_error("WARNING: blah,blah,blah") will count a warning and continue to run
        -- and any other dut_errors will be stopped so it can fixed.
        
        -- the six built-in check effects are as follows:
        -- ERROR           = stops the run immediately
        -- ERROR_BREAK_RUN = stops the run at clock cycle boundary
        -- ERROR_AUTOMATIC = stops the run & calls check() for every struct
        -- ERROR_CONTINUE  = counts an error, message in log and continues the run
        -- WARNING         = counts a warning, message in log and continues the run
        -- IGNORE          = no counting, nothing in log, continues the run
        
        set_check( "...",        ERROR_BREAK_RUN );  -- this order is important (must be first)
        set_check( "Warning...", WARNING         );  -- reports warning and continue to run
        set_check( "Error...",   ERROR_BREAK_RUN );  -- reports error and stop
      --set_check( "Fatal...",   ERROR           );  -- stop immediately (not even any more Ecode will be run)
    };
};
'>
