//********************************************************************************
//
//  Filename: cpubus_misc_structs.e
//
//  Description: misc structs for cpu bfm
//
//  Major Revision Descriptions:
//  oishi          09/08/02         copied from UMA1.0 branch
//
//*********************************************************************************

<'
---------------------
-- watch dog timer --
---------------------
struct WATCH_DOG_TIMER {
    clock_path : string;
    
    event rise_clock is rise('(clock_path)') @sim;
    
    TCM_start_timer( limit : uint ) @rise_clock is {
        var counter : uint;
        for{ counter = 0; counter < limit; counter += 1 } do {
            wait cycle;
        };
        stop_run();
    };
};

------------------
-- reset driver --
------------------
struct RESET_DRIVER {
    clock_path   : string;
    reset_path   : string;
    driver_delay : uint;
    
    keep soft driver_delay == 1;
       
    event rise_clock is rise ('(clock_path)') @sim;
    
    reset_drive( cycles : uint ) @rise_clock is {
      var counter : uint;
      
      wait delay(driver_delay);
      '(reset_path)' = 0;
      for{ counter = 0; counter < cycles; counter += 1 } do {
          wait cycle;
      };
      '(reset_path)' = 1;
    };
};

'>
